SewioRestClient::SewioRestConnection Class Reference

class for Sewio.net's RTLS Studio REST connections; returns SewioRestClient::SewioRestClient objects More...

Inheritance diagram for SewioRestClient::SewioRestConnection:
[legend]

## Public Member Functions

deprecated | constructor (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| DEPRECATED: creates the SewioRestConnection object. More...
| constructor (string name, string description, string url, hash< auto > attributes={}, hash< auto > options={})
| creates the SewioRestConnection object More...
*hash< auto > | getDefaultOptions ()
| returns default options
hash< auto > | getOptions ()
| gets options More...
string | getType ()
| returns `"sewiorest"`

## Static Public Member Functions

static deprecated SewioRestConnection | make (string name, string desc, string url, bool monitor, *hash opts, hash urlh)
| DEPRECATED: static constructor. More...

## Public Attributes

const | Options
| SewioRestConnection object connection options.

## Protected Member Functions

SewioRestClient | getImpl (bool connect=True, *hash< auto >rtopts)
| returns a SewioRestClient::SewioRestClient object More...

## Detailed Description

class for Sewio.net's RTLS Studio REST connections; returns SewioRestClient::SewioRestClient objects

supports the following options:

- `"apikey"`: (required) the Sewio.net's RTLS Studio api key
- `"connect_timeout"`: connection timeout to use in milliseconds
- `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
- `"data"`: see DataSerializationOptions for possible values; the default is `"json"`
- `"error_passthru"`: if True then HTTP status codes indicating errors will not cause a `REST-RESPONSE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
- `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
- `"max_redirects"`: maximum redirects to support
- `"proxy"`: proxy URL to use
- `"redirect_passthru"`: if True then redirect responses will be passed to the caller instead of processed
- `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
- `"timeout"`: transfer timeout to use in milliseconds

See also
  SewioRestClient::constructor() for more information on the above options

## Member Function Documentation

## constructor() [1/2]

deprecated SewioRestClient::SewioRestConnection::constructor | ( | string | name,
|  | string | desc,
|  | string | url,
|  | bool | monitor,
|  | *hash | opts,
|  | hash | urlh
| ) |  |

DEPRECATED: creates the SewioRestConnection object.

Parameters

  name | the name of the connection
  desc | connection description
  url | connection URL (potentially with password info)
  monitor | monitoring flag
  opts | connection options
  urlh | broken down URL hash (as returned by Qore::parse_url())

Exceptions

  SEWIORESTCONNECTION-ERROR | missing apikey option

Deprecated:
  since Qore 0.9

## constructor() [2/2]

SewioRestClient::SewioRestConnection::constructor | ( | string | name,
|  | string | description,
|  | string | url,
|  | hash< auto > | attributes = `{}`,
|  | hash< auto > | options = `{}`
| ) |  |

creates the SewioRestConnection object

Parameters

  name | the name of the connection
  description | connection description
  url | connection URL (potentially with password info)
  attributes | various attributes. See below
  options | connection options

See AbstractConnection::constructor() for `attributes` and `options` reference.

Exceptions

  SEWIORESTCONNECTION-ERROR | missing apikey option

## getImpl()

SewioRestClient SewioRestClient::SewioRestConnection::getImpl | ( | bool | connect = `True`,
|  | *hash< auto > | rtopts
| ) |  |

protected

returns a SewioRestClient::SewioRestClient object

Parameters

  connect | if True, then the connection is returned already connected
  rtopts | this connection type does not accept any runtime options, so this parameter is ignored

Returns
  a SewioRestClient object

## getOptions()

hash<auto> SewioRestClient::SewioRestConnection::getOptions | ( |  | ) |

gets options

Returns
  returns a hash with the following supported options:
  - `"apikey"`: the Sewio.net's RTLS Studio API key in use
  - `"connect_timeout"`: connection timeout to use in milliseconds
  - `"content_encoding"`: this sets the send encoding (if the `"send_encoding"` option is not set) and the requested response encoding; for possible values, see EncodingSupport
  - `"data"`: see RestClient::RestClient::DataSerializationOptions for possible values; the default is `"json"`
  - `"error_passthru"`: if True then HTTP status codes indicating errors will not cause a `REST-RESPONSE-ERROR` exception to be raised, rather such responses will be passed through to the caller like any other response
  - `"http_version"`: HTTP version to use (`"1.0"` or `"1.1"`, defaults to `"1.1"`)
  - `"max_redirects"`: maximum redirects to support
  - `"proxy"`: proxy URL to use
  - `"redirect_passthru"`: if True then redirect responses will be passed to the caller instead of processed
  - `"send_encoding"`: a send data encoding option or the value `"auto"` which means to use automatic encoding; if not present defaults to no content-encoding on sent message bodies
  - `"timeout"`: transfer timeout to use in milliseconds

See also
  SewioRestClient::constructor() for more information on the above options

## make()

static deprecated SewioRestConnection SewioRestClient::SewioRestConnection::make | ( | string | name,
|  | string | desc,
|  | string | url,
|  | bool | monitor,
|  | *hash | opts,
|  | hash | urlh
| ) |  |

static

DEPRECATED: static constructor.

Deprecated:
  since Qore 0.9 in favor of new constructor and Qore::Reflection